package simulation;
import java.awt.*;

public class Antrieb extends Simulationsmodell
{
//ACHTUNG: K und L sind gegenber Scilab-Musterlsung vertauscht!
    public double parP = 1.0;
    public double parI = 1.2;
    public double parD = 0.0;

    public double R=8.0;
    public double k=0.015;
    public double J=0.00045;
    public double D=0.0018;
    public double L=0.003;
    public double U=5.0;

    public double omega;
    public double icurr;

    public double ediff, d_ediff, i_ediff;

    public double WSOLL = 20.0;

    public Antrieb()
    {
        super(3); //Zwei Simulationsgleichungen
    }

    public double[] berechneRechteSeite(double[] yalt, double t)
    {
        omega = yalt[0];
        icurr = yalt[1];

        ediff = WSOLL - omega;
        d_ediff = -( (-D/J)*omega + (k/J)*icurr );
        i_ediff = yalt[2];

        parP = 1.0;
        parI = 1.2;
        parD = 0.0;

        U = parP*ediff + parI*i_ediff + parD*d_ediff;

        /**Eigentliche Bestimmung der rechten Seite (Steigungsvektor)*/
        f[0] = (-D/J)*omega + (k/J)*icurr;
        f[1] = (-k/L)*omega + (-R/L)*icurr + U/L;
        f[2] = ediff;
        return f;
    } 

    /** paint(..) wird bei der Konsolenanwendung nicht verwendet.*/
    public void paint(Graphics2D g)
    {
    }
}