package opti;

public class Optimierer
{
    //Fehlerfunktion
    public double fehlerfunktion(double[] param)
    {
        double x = param[0];
        double y = param[1];

        return x*x*x - 4.0*x + y*y*y - 16.0*y; 
    }

    public double[] optimieren(double[] start_param, double start_alfa,int anzahl_schritte)
    {
        int param_anzahl = start_param.length;

        //-2 -1 -0.5 0 0.5 1 2
        double[] faktoren = {-2.0,-1.0,-0.5,0.0,0.5,1.0,2.0};
        double[] merker = new double[7*param_anzahl];    
        double[] psatz_alt = new double[param_anzahl];
        double[] psatz_such = new double[param_anzahl];
        double[] alfa_alt = new double[param_anzahl];
        double[] alfa_neu = new double[param_anzahl];

        double[] psatz_neu = new double[param_anzahl];


        double fehler_akt;
        int    fehlerindex_akt;
        double param_akt;
        double fehler_best; //in einem Durchlauf gerade bester Fehler mit aktuell bestem Parametersatz

        for(int i=0;i<param_anzahl;i++)
        {
           psatz_alt[i] = start_param[i];
           alfa_alt[i] = start_alfa;
        }

        for(int i=0;i<anzahl_schritte;i++)
        {
            //1. Schritt
            //Fehler fr alle Varianten berechnen:
            for(int ii=0;ii<param_anzahl;ii++)
            {
                //psatz_such auf psatz_alt setzen:
                for(int pp=0;pp<param_anzahl;pp++)
                    psatz_such[pp] = psatz_alt[pp];

                for(int kk=0;kk<7;kk++)
                {
                    psatz_such[ii] = psatz_alt[ii] + faktoren[kk]*alfa_alt[ii];                                
                    merker[ii*7+kk] = fehlerfunktion(psatz_such);
                }
            }
            //2. Schritt
            //Bestimmung des neuen Parametersatzes und der neuen Alfa-Werte
            for(int ii=0;ii<param_anzahl;ii++)
            {
                //Index des kleinsten Fehlers bestimmen:
                fehler_akt = merker[ii*7+0];
                fehlerindex_akt = 0;
                for(int kk=1;kk<7;kk++)
                {
                    if(merker[ii*7+kk]<fehler_akt)
                    {
                        fehler_akt = merker[ii*7+kk];
                        fehlerindex_akt = kk;
                    }
                }
                //Neuen Parameter-Startpunkt festlegen fr die aktuelle Komponente
                psatz_neu[ii] = psatz_alt[ii] + faktoren[fehlerindex_akt]*alfa_alt[ii]; 
                //Neues Alfa bestimmen:
                alfa_neu[ii] = faktoren[fehlerindex_akt]*alfa_alt[ii];
                if(alfa_neu[ii]==0.0)
                    alfa_neu[ii] = 0.25*alfa_alt[ii];
                if(alfa_neu[ii]<0.0)
                    alfa_neu[ii] = -alfa_neu[ii];
            }

            //3. Schritt
            //Umkopieren fr neuen Durchlauf:
            for(int ii=0;ii<param_anzahl;ii++)
            {
                psatz_alt[ii] = psatz_neu[ii]; 
                alfa_alt[ii]  = alfa_neu[ii];
            }        

            fehler_best = fehlerfunktion(psatz_neu);
            System.out.print("Nr."+i+" f="+fehler_best+"    ");

            for(int ii=0;ii<param_anzahl;ii++)
            {
                System.out.print(psatz_neu[ii]+" ");
            }
            System.out.println();
        }
        return psatz_neu;
    }

    public static void main(String[] args)
    {
        int panz = 2;
        double start_alfa = 1.0;
        double[] start_param = {4.0,4.0};

        Optimierer optimierer = new Optimierer();

        double[] best_param = optimierer.optimieren(start_param,start_alfa,100);

        for(int i=0;i<panz;i++)
        {
             System.out.println("Bester Parameter Nr."+i+": "+best_param[i]);
        }
    }
}


