package simulation;

import hilfsklassen.Parser;
import hilfsklassen.Dateioperationen;
import hilfsklassen.Aufruf;

public class TestAntrieb
{
    public static void main(String[] args)
    {
        Antrieb antrieb = new Antrieb();
        RungeKuttaIntegrator rungekuttaintegrator = new RungeKuttaIntegrator();
        rungekuttaintegrator.add(antrieb);

//ACHTUNG: K und L sind gegenber der Scilab-Musterlsung in Kaptiel 5.6 vertauscht!
        antrieb.parP=1.0;
        antrieb.parI=1.2;
        antrieb.parD=0.0;
        
        antrieb.WSOLL = 20.0;

        double dt = 0.001;
        double  t = 0.0;
        double[] y;
        double[] yalt = {0.0,0.0,0.0};

        StringBuffer sb = new StringBuffer();

        while(t<10.0)
        {
            sb.append(t+" "+yalt[0]+"\n");
            y = rungekuttaintegrator.zeitschritt(yalt,t,dt);

            yalt[0] = y[0];
            yalt[1] = y[1];
            yalt[2] = y[2];
            t+=dt;
        }
        String data = sb.toString();
        data = Parser.ersetze(data,".",",");
        Dateioperationen.speichern("./data.txt",data);

        Aufruf.befehl("scilab -f datashow.sce");
    }
}